/* chat.c

  Routines for installing the chat server.

 Chris Eleveld      (The Insane Hermit)
 Robert Slaven      (The Celestial Knight/Tigger)
 Jerry Bolton, Jr.  (Creel)
 Dave Mott          (Energizer Rabbit)

*/

#include <stdio.h>
#include <sys/types.h>
#ifdef POSIX
#include <sys/select.h>
#endif
#include <sys/time.h>
#include <sys/resource.h>

#include <errno.h>
#include <ctype.h>
#include "lorien.h"

extern void *malloc(); 

#ifndef POSIX
extern char *index();
#else
extern char *strchr();
#endif

#ifndef errno
extern int errno;
#endif

extern int getsock(), infromsock(), outtosock(), acceptcon(), atoi();

extern struct splayer *players;	  /* the linked list of players records */

char recvbuf[BUFSIZE]; 
char sendbuf[OBUFSIZE];

int s;			/* our initial socket */

int
doit(port)
    int port;
{
    fd_set needread;		/* for seeing which fds we need to read from */
    int num;			/* the number of needy fds */
    int max;                     /* The highest fd we are using. */

    initplayerstruct();

    if (gethostname(sendbuf, sizeof(sendbuf)) == -1) {
	fprintf(stderr, "lorien: Error getting hostname!\n");
	exit(2);
    }

    fprintf(stderr, "Establishing a socket on %s on port %d...\n", sendbuf,
            port);

    s = getsock(sendbuf, port);
    fprintf(stderr, "Socket established for Lorien on port %d.\n",port);

    MAXCONN = gettablesize();

    while (1) {

	FD_ZERO(&needread);
	FD_SET(s, &needread);
	max = setfds(&needread);

	if ((num = select(max + 1, &needread, (fd_set *)0,
			  (fd_set *)0, (struct timeval *)0)) == -1) {

	    if (errno != EINTR) {
		perror("lorien select failed");
		continue;
	    } else
		continue; /* do it again and get it right */
	}

	if (FD_ISSET(s, &needread)) 
	    if (newplayer(s) == -1) 
		fprintf(stderr, "lorien: ran out of file descriptors!\n");

	handleinput(needread);
    }
     
	/*NOTREACHED*/   /* Don't ya just love LINT? */
    return 0;
}

